<?php

/* public */ class dispatcher extends serializeableObject {

  /* private String */    var $filename  = "";
  /* private Hashtable */ var $config    = array(); # configuration

  /* constructor */ function dispatcher(/* String */ $filename) {
    settype($filename, "string");
    $this->filename = $filename;
    $this->config = getConfigFile($filename,true);
  }

  /* public boolean */ function notify(/* String */ $event, /* Hashtable */ $ARGS) {
    settype($event, "string");
    settype($ARGS, "array");
    global $PROGRAM;
    $event = strtoupper($event);

    if (isset($this->config["INTERFACE"][$event][TYPE])) {
      /* String */ $criteria = $this->config["INTERFACE"][$event][TYPE];
    } else {
      /* String */ $criteria = $this->config["DEFAULT"][TYPE];
    }
    $event = strtolower($event);
    return $PROGRAM->plugins->notify($event, $ARGS, $criteria);
  }

  /* public mixed */ function get(/* String */ $event, /* String */ $key) {
    settype($event, "string");
    settype($key, "string");
    $event = strtoupper($event);
    $key = strtoupper($key);

    if (isset($this->config["INTERFACE"][$event][$key])) {
      return $this->config["INTERFACE"][$event][$key];
    } else {
      return $this->config["DEFAULT"][$key];
    }

  }
  
  /* public boolean */ function addInterface(/* String */ $filename) {
    if (!file_exists($filename))  {
      echo "<P>WARNING: Interface file \"$filename\" could not be found. Plugin may be corrupt.</P>\n";
      return false;
    }
    $REF = getConfigFile($filename,true);
    if (!isset($REF["INTERFACE"]))  {
      echo "<P>WARNING: Interface file \"$filename\" is corrupt. Plugin could not be loaded.</P>\n";
      return false;
    }
    $test = true;
    foreach ($REF["INTERFACE"] as $a => $b) {
      if (isset($this->config[$a])) {
        echo "<P>WARNING: Interface conflict found. Plugin \"$filename\" collides in event-key \"$a\" with another installed plugin and could not be loaded. Please check your configuration (and possibly inform the author of the plugin to solve this problem).</P>\n";
        $test = false;
      }
    }
    if (!$test) return false;
    $this->config["INTERFACE"] += $REF["INTERFACE"];
    return true;
  }

  /* public String */ function toString() {
    if ($this->config) {
      $txt = "Dispatcher - Interface settings:\n\tdefault settings\n\t{\n";
      foreach ($this->config["DEFAULT"] as $a => $b) {
        $txt .= "\t\t- $a = $b\n";
      }
      $txt .= "\t}\n";
      foreach ($this->config["INTERFACE"] as $a => $b) {
        if (gettype($b) == "array") {
          $txt .= "\tevent \"$a\"\n\t{\n";
          foreach ($b as $c => $d) {
            $txt .= "\t\t- $c = $d\n";
          } # end for
          $txt .= "\t}\n";
        } # end if
      } # end for
      return $txt;
    } else {
      return "Dispatcher has no interface loaded.\n";
    } # end if
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

}

$copyright = urldecode("%3Cp%20class%3D%22KOMMENTAR%22%20style%3D%22text-align%3A%20center%22%3EWebTools%20powered%20by%20%3CA%20HREF%3D%22http%3A%2F%2Fwww.All-Community.de%22%20target%3D%22_blank%22%20title%3D%22Die%20Community%20der%20Webmaster%22%3E%3Cspan%20style%3D%22color%3A%236495ED%22%3Ewww.%3C%2Fspan%3E%3Cspan%20style%3D%22color%3A%23FFA500%22%3E%20All%20-%20Community%20%3C%2Fspan%3E%3Cspan%20style%3D%22color%3A%236495ED%22%3E.de%3C%2Fspan%3E%3C%2FA%3E");

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
