<?php

class secureFileStream extends secureInputStream {

   function insert($text) {
     $this->content[count($this->content)] = $text;
   }

   function write() {
     settype($this->content, "array");
     if ($this->is_writeable() && $this->checksum()) {
       $datei = fopen($this->filename, "w+"); flock($datei, 2);
       fwrite($datei, implode("", $this->content));
       flock($datei, 3); fclose($datei);
       return true;
     } else {
       return false;
     }
   }

   function failSafeWrite() {
     for ($i=0; $i<3; $i++) {
       if ($this->write()) {
         return true;
         break;
       } else {
         sleep(0.7);
       }
     }
     return false;
   }

   function create() {
     if (!$this->exists() && $this->checksum() && $this->filename) {
       fclose(fopen($this->filename, "w+"));
       $this->read();
       return true;
     } else {
       return false;
     }
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   function is_writeable() {
     return ( $this->exists() && is_writeable($this->filename) );
   }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
