<?php

/* public */ class sessionManager extends serializeableObject {

   /* private mixed */ var $data;

   function sessionManager($data) {
     @session_start();
     $this->data = $data;
     if (method_exists($data,"init")) $this->data->init();
   }

  /* public boolean */ function checkLogin($user_name,$user_pwd) {
    settype($user_name, "string");
    settype($user_pwd, "string");
    $user_name = strtoupper($user_name);     
                                      
    if (!$this->data->keyExists("USERS/$user_name")) return false;
    $haben = $this->encode($user_name,$user_pwd);
    $soll  = $this->data->getKey("USERS/$user_name/PASSWORT");
    if ($soll == "UNINITIALIZED") return true;
    if ($haben != $soll) return false;
    return true;
  }

  /* public boolean */ function isLoggedIn() {
    global $HTTP_SESSION_VARS;

    if (!isset($HTTP_SESSION_VARS[user_pwd]) || !isset($HTTP_SESSION_VARS[user_name])) {
      return false;
    } else {
      $haben = $this->createKey2($HTTP_SESSION_VARS[user_pwd]);
      $soll  = $this->data->getKey("USERS/".$HTTP_SESSION_VARS[user_name]."/PASSWORT");
      if ($soll == "UNINITIALIZED") return true;
      return $haben == $soll;
    } # end if
  }

  /* public boolean */ function login($name,$pwd) {
    settype($name, "string");
    settype($pwd, "string");
    @session_start();

    if ($this->checkLogin($name,$pwd)) {
      $name = strtoupper($name);
      $pwd  = $this->createKey1($name,$pwd);
      $_SESSION["user_name"] = $name;
      $_SESSION["user_pwd"]  = $pwd;
      return true;
    } else {
      return false;
    } # end if
  }
  
  /* public boolean */ function logout() {
    @session_destroy();
    $this->data->close();
    return true;
  }

  /* public boolean */ function changePwd($user_name,$user_pwd) {
    settype($user_name, "string");
    settype($user_pwd, "string");

    if ($this->isLoggedIn()) {  
      return $this->data->changePwd($user_name,$this->encode($user_name,$user_pwd));
    } else {
      return false;           	
    } # end if
  }

  /* public boolean */ function setPwd($user_name) {
    settype($user_name, "string");

    if (!$this->userExists($user_name)) return false;

    $user_pwd = sessionManager::generatePassword();

    if ($this->isLoggedIn()) {
      if (!$this->data->changePwd($user_name,$this->encode($user_name,$user_pwd))) {
        return false;
      } else {
        return $user_pwd;
      }
    } else {
      return false;
    } # end if
  }

  /* public boolean */ function insertUser($user_name,$INPUT) {
    settype($user_name, "string");
    settype($INPUT, "array");

    return $this->data->insertUser($user_name,$INPUT);
  }

  /* public boolean */ function removeUser($user_name) {
    settype($user_name, "string");

    return $this->data->removeUser($user_name);
  }

  /* public mixed */ function getUserPermission(/* String */ $user_name,/* String */ $id) {
    settype($user_name, "string");
    settype($id, "string");

    return $this->data->getUserPermission($user_name, $id);
  }

  /* public boolean */ function isEmpty() {
    return $this->data->isEmpty();
  }

  /* public Hashtable */ function getUserList() {
    $i = 0; $REF = array();
    $SOURCE = $this->data->get("*");
    settype($SOURCE, "array");
    settype($SOURCE[USERS], "array");

    foreach ($SOURCE[USERS] as $a => $b) {
      $REF[$i][USER] = $this->createUserHash($a, $b, false);
      $i++;
    }
    return $REF;
  }

  /* public Hashtable */ function getUserGroups() {
    $i = 0; $REF = array();
    $SOURCE = $this->data->get("GROUP");
    settype($SOURCE, "array");

    foreach ($SOURCE as $a => $b) {
      $REF[$i][GROUP][ID]    = $a;
      $REF[$i][GROUP][NAME]  = $b[NAME];
      $REF[$i][GROUP][VALUE] = $b[VALUE];
      $i++;
    }
    return $REF;
  }
  
  /* public Hashtable */ function getUser(/* String */ $name) {
    settype($name, "string");
    $name = strtoupper($name);

    $REF = $this->data->getKey("USERS/$name");
    return $this->createUserHash($name, $REF, true);
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

  /* public boolean */ function userExists(/* String */ $user_name) {
    settype($user_name, "string");
    $user_name = strtoupper($user_name);
    return $this->data->keyExists("USERS/$user_name");
  }

  /* public static String */ function generatePassword() {
    return substr(uniqid(""),0,10);
  }

  /* private static String */ function encode($a, $b) {
    settype($a, "string");
    settype($b, "string");
    return sessionManager::createKey2(sessionManager::createKey1($a,$b));
  }

  /* private static String */ function createKey1($a, $b) {
    settype($a, "string");
    settype($b, "string");
    $a = substr(strtoupper($a),0,2);
    return md5($a.$b);
  }
  
  /* private static String */ function createKey2($a) {
    settype($a, "string");
    return md5($a);
  }

  /* private Hashtable */ function createUserHash(/* String */ $name, /* Hashtable */ $data, /* boolean */ $i) {
    settype($name, "string");
    settype($data, "array");
    $name = strtoupper($name);

    unset($data[PASSWORT]);
    unset($data[PASSWORD]);
    $REF     = $data;
    unset($REF[PERMISSION]);
    unset($REF[TYPE]);

    $REF[ID] = $name;

    if (!isset($data[TYPE]) ||is_int($data[TYPE])) {
      $REF[TYPE][NAME]  = $data[TYPE];
      $REF[TYPE][VALUE] = $data[TYPE];
    } else {
      $REF[TYPE][NAME]  = $this->data->getKey("GROUP/".(strtoupper($data[TYPE]))."/NAME");
      $REF[TYPE][VALUE] = $data[TYPE];
    }
    settype($data[PERMISSION], "array");
    foreach ($data[PERMISSION] as $c => $d) {
      if (is_int($d)) {
        if ($i) {
          $REF[PERMISSION][$c][ID]    = $c;
          $REF[PERMISSION][$c][VALUE] = $d;
          $REF[PERMISSION][$c][NAME]  = $d;
        } else {
          $REF[PERMISSION]    .= "$c = $d<br>";
        }
      } else {
        if ($i) {
          $REF[PERMISSION][$c][ID]    = $c;
          $REF[PERMISSION][$c][VALUE] = $this->data->getKey("GROUP/".(strtoupper($d))."/NAME");
          $REF[PERMISSION][$c][NAME]  = $d;
        } else {
          $REF[PERMISSION]    .= "$c = ".$this->data->getKey("GROUP/".(strtoupper($d))."/NAME")."<br>";
        }
      }
    }
    
    return $REF;
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
