<?php

class template extends secureInputStream {

   /* constructor */ function template(/* String */ $filename) {

     if (preg_match("/.*\.(register|config|cfg|lock|dat|htaccess)/Ui", $filename)) {
       $this->source = "<H1>FEHLER 403</H1><P>Datei &quot;$filename&quot; ist auf diesem Server nicht vorhanden und/oder nicht freigegeben</P>";
       $this->exists = false;
       unset($this->filename);
     } elseif (!file_exists($filename) || !is_readable($filename)) {
       $this->source = "<H1>FEHLER 404</H1><P>Datei &quot;$filename&quot; ist auf diesem Server nicht vorhanden</P>";
       $this->exists = false;
      unset($this->filename);
     } else {
       $this->attributes[MTIME] = date("d.m.Y",filemtime($filename));
       $this->attributes[ATIME] = date("d.m.Y H:i:s",fileatime($filename));
       $this->attributes[CTIME] = date("d.m.Y",filectime($filename));
       global $REMOTE_ADDR; if (isset($REMOTE_ADDR)) { $this->attributes[REMOTE_ADDR] = $REMOTE_ADDR; }
       $this->exists = true;
       $this->filename = $filename;
     }
     clearstatcache();

   }

   /* public boolean */ function read() {

     if ($this->filename=="" || !is_readable($this->filename)) { return false; }

     $txt = file($this->filename);
     $txt = implode("", $txt);
     $this->source = $txt;
     $this->dateipfadeKorrigieren();
     $this->content = $this->source;
     $this->options = $this->attributes;
     return true;

   }

   /* public void */ function replace(/* String */ $token,/* String */ $replace) {
     settype($token,   "string");
     settype($replace, "string");

     $this->content = preg_replace("/<?".$this->toRegExp($token).">?/Ui", $replace, $this->content);

   }

   /* public String */ function get() {

     GLOBAL $PROGRAM;

     $this->fill($PROGRAM->getRegistryKey('LANGUAGE'));
     $this->fill($PROGRAM->getRegistryKey('*'));
     $this->exec($PROGRAM->getRegistryKey('<BOOLEAN>'));
     return $this->content;

   }

   /* public void */ function write() {

     $this->doImports();
     $text = $this->get();
     $text = preg_replace("/<%COMMENT%>.*<%\/COMMENT%>/Usi", "", $text);
     $text = preg_replace("/<?%\/?([\w\._ ]?)*%>?/i", "", $text);
     echo $text;
   
   }
/**********************************************************************************************
* Sekundrfunktionen
**********************************************************************************************/

   /* public void */ function insertAtTag(/* String */ $include,/* String */ $tag) {
     settype($include, "string");
     settype($tag,     "string");

     $matches = array();
     if (preg_match("/<head[^>]*>.*<\/head>/Usi", $include, $matches)) {
       $this->content = preg_replace("/<head[^>]*>.*<\/head>/Usi", $matches[0], $this->content);
       $include = preg_replace("/<head[^>]*>.*<\/head>/Usi", "", $include);
     }
     if (preg_match("/<body[^>]*>(.*)<\/body>/Usi", $include, $matches)) {
       $this->replace("<%".$tag."%>", $matches[1]);
       $this->replace("%".$tag."%", $matches[1]);
     } else {
       $this->replace("<%".$tag."%>", $include);
       $this->replace("%".$tag."%", $include);
     }

     $this->replace("%IF ".$tag."%", "");

   }
   
   /* public boolean */ function insertFileAtTag(/* String */ $include,/* String */ $tag) {
     settype($include, "string");
     settype($tag,     "string");

     $temp = new document($include);
     /* boolean */ $bool = $temp->readBody();
     $this->insertAtTag("<!-- START imported section: $include -->\n".$temp->content."<!-- END imported section: $include checksum=".crc32($temp->content)." -->",$tag);

     return $bool;
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   /* private void */ function dateipfadeKorrigieren() {

     if (preg_match("/^.*\//", $this->filename, $match1)) {
       preg_match_all('/ background\s?=\s?"(\S*)"/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match('/^https?:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace('/ background\s?=\s?"'.$this->toRegExp($match2[1][$i]).'"/i', ' background="'.$match1[0].$match2[1][$i].'"', $this->source);
         }
       }
       preg_match_all('/ src\s?=\s?"(\S*)"/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match('/ src\s?=\s?"\S*"/i', $match2[1][$i]) && !preg_match('/^https?:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace('/ src\s?=\s?"'.$this->toRegExp($match2[1][$i]).'"/i', ' src="'.$match1[0].$match2[1][$i].'"', $this->source);
         }
       }
       preg_match_all("/\.src\s?=\s?'(\S*)'/i", $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match("/\.src\s?=\s?'\S*'/i", $match2[1][$i]) && !preg_match('/^https?:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace("/\.src\s?=\s?'".$this->toRegExp($match2[1][$i])."'/i", ".src='".$match1[0].$match2[1][$i]."'", $this->source);
         }
       }
       preg_match_all("/ url\('([^']*)'\)/i", $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match("/ url\('[^']*'\)/i", $match2[1][$i]) && !preg_match('/^https?:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace("/ url\('".$this->toRegExp($match2[1][$i])."'\)/i", " url('".$match1[0].$match2[1][$i]."')", $this->source);
         }
       }
       preg_match_all('/ href\s?=\s?"([^"]*)"/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         if (!preg_match('/ href\s?=\s?"\S*"/i', $match2[1][$i]) && !preg_match('/^javascript:/i', $match2[1][$i]) && !preg_match('/^\&\#109\;\&\#97\;\&\#105\;\&\#108\;\&\#116\;\&\#111\;\&\#58\;\S*/i', $match2[1][$i]) && !preg_match('/^mailto:\S*/i', $match2[1][$i]) && !preg_match('/^https?:\/\/\S*/i', $match2[1][$i]) && !preg_match('/^%PHP_SELF%/i', $match2[1][$i])) {
           $this->source = preg_replace('/ href\s?=\s?"'.$this->toRegExp($match2[1][$i]).'"/i', ' href="'.$match1[0].$match2[1][$i].'"', $this->source);
         }
       }
       preg_match_all('/<?%IMPORT ([^%]*)%>?/i', $this->source, $match2);
       for ($i=0;$i<count($match2[1]);$i++) {
         $this->source = preg_replace('/<?%IMPORT '.$this->toRegExp($match2[1][$i]).'%>?/i', '%IMPORT '.$match1[0].$match2[1][$i].'%', $this->source);
       }
       $this->source = preg_replace('/(<META HTTP-EQUIV="Refresh"[^>]*URL=\%PHP_SELF\%\?)/i', "$1".session_name()."=".session_id()."&amp;", $this->source);
     }

   }

   /* public void */ function fill(/* Hashtable */ $REF) {
     settype($REF, "array");

     $this->content = layout::fillTemplate($this->content, $REF, true);

   }

   /* private void */ function doImports() {
       $match=array();        
       while (preg_match_all('/<?%IMPORT ([^%]*)%>?/si', $this->content, $match)) {
         for ($i=0;$i<count($match[1]);$i++) {
           $this->insertFileAtTag($match[1][$i],"IMPORT ".$match[1][$i]);
         }
       }
   }

   /* private void */ function exec(/* Hashtable */ $REF) {
     settype($REF, "array");
     $this->content = layout::execCommands($this->content, $REF);
   }

   /* private static String */ function toRegExp(/* String */ $string) {
     settype($string, "string");
     return toRegExp($string);
   }
   
   /* private int */ function length() {
     return strlen($this->content);
   }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
