<?php

class textfile extends datfile {

   function get($line_nr) {
     $data      = $this->content[$line_nr];
     $REF       = $this->getRawData($line_nr);
     $TXT       = array();
     foreach ($REF as $key=>$element) {
       $TXT[strtoupper($key)] = scanForAt(embeddedTags(addSmilies($element)));
     }
     return $TXT;
   }
   
   function getRawData($line_nr) {
     $data      = $this->content[$line_nr];
     $REF       = array();
     while (preg_match("/<(.*)>(.*)<\/.*>/Ui", $data, $matches)) {
       $matches[2]       = preg_replace("/(\S{80})(\S*)/i", "\\1<wbr>\\2", $matches[2]);
       $REF[$matches[1]] = $matches[2];
       $data             = preg_replace("/<".$matches[1].">.*<\/.*>/Ui", "", $data);
       $matches          = array();
     }
     return $REF;
   }

   function replace($line_nr, $REF) {
     $txt = "";
     if (gettype($REF)=="array" && gettype($line_nr)=="integer") {
       $ORIGINAL = $this->getRawData($line_nr);
       foreach ($REF as $key => $element) {
         if ($REF[$key] != $ORIGINAL[$key]) {
           $element = $this->chkInputData($element);
         }
         $txt    .= $this->makeData($key,$element);
       }
       $txt       = preg_replace("/>http:\/\//i",">",$txt);
       $txt       = nl2br($txt);
       $txt       = preg_replace("/\s/"," ",$txt);
       $txt      .= "\n";
       $this->content[$line_nr] = $txt;
       return true;
     } else {
       return false;
     }
   }

   function insert($REF) {
     if (gettype($REF)=="array") {
       $txt       = "";
       foreach ($REF as $key => $element) {
         $element = $this->chkInputData($element);
         $txt    .= $this->makeData($key,$element);
       }
       $txt       = preg_replace("/>http:\/\//i",">",$txt);
       $txt       = nl2br($txt);
       $txt       = preg_replace("/\s/"," ",$txt);
       $txt      .= "\n";
       if (!$this->isEmpty()) {
         array_unshift($this->content,$txt);
       } else {
         $this->content[0] = $txt;
       }
       return true;
     } else {
       return false;
     }
   }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

   function antiFlooding($text) {
     settype($text,"string");
     $text = trim($text);
     $text = preg_replace("/^(.{2000}\S*).*/", "\\1", $text);
     $text = preg_replace("/^(.{2100}).*/", "\\1", $text);

     $text = preg_replace("/\[\/\S+\]/U", "\\0 ", $text);
     $text = preg_replace("/\[[^\s\/]+\]/U", " \\0", $text);
     $text = preg_replace("/\:\S+\:/U", " \\0 ", $text);
     $text = preg_replace("/(\S{40})(\S)/", "\\1[wbr]\\2", $text);
     $text = preg_replace("/\[wbr\]\[wbr\]/", "[wbr]", $text);
     return $text;
   }

   function makeData($key,$element) {
     settype($key,"string");
     settype($element,"string");
     return "<".strtoupper($key).">$element</".strtoupper($key).">";
   }

   function chkInputData($text) {
     settype($text,"string");
     $text = $this->antiFlooding($text);
     $text = htmlentities(stripcslashes(trim($text)));
     return $text;
   }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
