<?php

/* public */ class plugin_rss extends plugin {

  /* private string[] */ var $rss;

  // "file" should be a valid path to an existing XML-File
  /* private string */ var $file;

  // maximum number of entries to show
  /* private integer */ var $max;

  /* constructor */ function plugin_rss($plugin_name) {
    settype($plugin_name,"string");
    $this->plugin_name = $plugin_name;

    {  # <--- LOAD PLUGIN-CONFIGURATION

        global $PROGRAM;
        $this->file = $PROGRAM->plugins->getRegistryKey($this->plugin_name, "PROFILE/RSSFILE");
        $this->max  = $PROGRAM->plugins->getRegistryKey($this->plugin_name, "PROFILE/MAX");
        settype($this->file, "string");
        settype($this->max, "integer");
        
        if (!$this->max>0) $this->max = 5;

    }  # FINISHED --->
  }

  /* public void */ function listener(/* String */ $event, /* Hashtable */ $ARGS) {
     settype($event, "string");
     settype($ARGS, "array");
     $event = strtolower($event); global $PROGRAM;

     switch ($event) {

       case "get_news":

         // simpleXML is faster - but not always available

         if (extension_loaded("Simplexml")) $this->get_simpleXML();

         // XML-Parser should be available anyway - somewhat slower

         if (!extension_loaded("Simplexml")) $this->get_xmlParser();
         
         /*
          $this->rss should now contain the news-feed data
          -> move it to cache, so it can be read by the GUI
        */

         $PROGRAM->setRegistryKey("RSS", array_slice($this->rss,0,$this->max));
         $PROGRAM->setRegistryKey("RSSFILE", $this->file);

       break;

     } # end switch
     return true;
  }

  /* private String */ function get_xmlParser(/* void */) {
      $xml_parser = xml_parser_create();
      xml_set_element_handler($xml_parser, "startElement", "endElement");
      xml_set_character_data_handler($xml_parser, "characterData");
      if (!($fp = @fopen($this->file, "r"))) {
          die("<H1>ERROR 500</H1><P>Could not open XML input. Check if &quot;".$this->file."&quot; is a correct path to a valid XML file!</P>");
      }
      
      while ($data = fread($fp, 4096)) {
          if (!xml_parse($xml_parser, $data, feof($fp))) {
              die(sprintf("XML error: %s at line %d",
                          xml_error_string(xml_get_error_code($xml_parser)),
                          xml_get_current_line_number($xml_parser)));
          }
      }
      xml_parser_free($xml_parser);
      global $REF;
      $this->rss = $REF[ITEM];

  }

  /* private String */ function get_simpleXML(/* void */) { 

      if (! $RSS_feed = @simplexml_load_file($this->file)) {
         die("<H1>ERROR 500</H1><P>Could not open XML input. Check if &quot;".$this->file."&quot; is a correct path to a valid XML file!</P>");
      }
  
      $this->rss = array();
  
      foreach ($RSS_feed->channel->item as $item) {
  
         $i = count($this->rss);
  
         if ($item->link) $this->rss[$i][LINK] = (string) $item->link;
         $this->rss[$i][TITLE]    = $item->title;
         $this->rss[$i][DESCRIPTION] = plugin_rss::rssStringDecode((string) $item->description);
         if ($item->author) $this->rss[$i][AUTHOR] = (string) $item->author;
         $this->rss[$i][PUBDATE]  = (string) $item->pubDate;
         if ($item->category) $this->rss[$i][CATEGORY] = (string) $item->category;
  
         $i++;
      } // end for

  }

  // Transformes common escape-sequences to html entities
  /* public static String */ function rssStringDecode(/* String */ $t) {
    settype($t, "string");

    $t = str_replace('ß', '&szlig;', $t);
    $t = str_replace('Ö', '&Ouml;', $t);
    $t = str_replace('ö', '&ouml;', $t);
    $t = str_replace('Ü', '&Uuml;', $t);
    $t = str_replace('ü', '&uuml;', $t);
    $t = str_replace('Ä', '&Auml;', $t);
    $t = str_replace('ä', '&auml;', $t);
    $t = str_replace('€', '&euro;', $t);
    return $t;
  
  }

}

function startElement($parser, $name, $attrs)
{
    global $regAdress;
    global $REF;
    if (!$regAdress) {
      $regAdress = $name;
    } else {
      if ($name == "ITEM") {
        $count = count($REF[ITEM]);
        $regAdress = "ITEM/".$count;
      } else if (preg_match("/title|pubDate|description|link|author|category|comments/i", $name)) {
        $regAdress .= "/".$name;
      }
    }

}

function endElement($parser, $name)
{
    global $regAdress;
    global $REF;
    if ($name == "ITEM") {
      $regAdress = preg_replace("/(.*)\/.*\/.*/", "\\1", $regAdress);
    } else {
      $regAdress = preg_replace("/(.*)\/.*/", "\\1", $regAdress);
    }
}

function characterData($parser, $data)
{
    global $regAdress;
    global $REF;

    if ( trim($data) ) {
        if (!preg_match("/LINK/i", $getAdress)) {
          $data = preg_replace("/'/", "\\'", plugin_rss::rssStringDecode($data));
        }
    
        $a = decodeAdress($regAdress);
        eval("\$REF$a = '".$data."';");
    }
}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
