<?php

/* public */ class user_security extends serializeableObject {

  /* private sessionManager */ var $sessionManager;
  /* private String */         var $user_name;

/*********************************************************************************************/

   /* constructor */ function user_security(/* String */ $file) {
      session_start();
      global $PROGRAM, $HTTP_SESSION_VARS;

      if ($HTTP_SESSION_VARS[user_name]) {
        $this->user_name = $HTTP_SESSION_VARS[user_name];
        $PROGRAM->setRegistryKey("SESSION_USER_ID", $this->user_name);
      }
      $this->sessionManager = new sessionManager($file);
      $PROGRAM->setRegistryKey("SESSION_ID", session_id());
      $PROGRAM->setRegistryKey("SESSION_NAME", session_name());
   }


  /* public boolean */ function set_pwd(/* String */ $pwt_alt, /* String */ $pwt_neu) {
    settype($pwt_alt,"string");
    settype($pwt_neu,"string");
    global $PROGRAM;

    if (!$this->sessionManager->checkLogin($this->user_name,$pwt_alt)) {
     $PROGRAM->meldung("fehler", "LOGIN_UNGUELTIG", "");
     return false;
    }
    if (!$this->sessionManager->changePwd($this->user_name,$pwt_neu)) {
     $PROGRAM->meldung("fehler", "500", "index");
     return false;
    } else {
     $PROGRAM->meldung("danke", "200", "index");
     return false;
    }
  }

  /* public boolean */ function get_login(/* Hashtable */ $ARGS) {
    settype($ARGS, "array");

    session_start();
    global $PROGRAM;
    $form_params = '<input type="hidden" name="target" value="'.$ARGS[target].'">'.
                   '<input type="hidden" name="id" value="'.$ARGS[id].'">'.
                   '<input type="hidden" name="action" value="check_login">'.
                   '<input type="hidden" name="'.session_name().'" value="'.session_id().'">';
    $PROGRAM->setRegistryKey("FORM_PARAMS", $form_params);
    return false;
  }

  /* public boolean */ function get_logout() {
    global $PROGRAM;
    $this->sessionManager->logout();
    $PROGRAM->meldung("danke", "LOGOUT", "");
    return false;
  }

  /* public boolean */ function login(/* String */ $nutzername, /* String */ $passwort) {
    settype($nutzername, "string");
    settype($passwort, "string");

    session_start();
    global $PROGRAM,$HTTP_SESSION_VARS;
    if ($this->sessionManager->login($nutzername,$passwort)) {
      $USER = $this->sessionManager->getUser($nutzername);
      settype($USER[COUNT_LOGINS], "integer");
      $this->sessionManager->insertUser($nutzername, array(LAST_LOGIN => time(), COUNT_LOGINS => $USER[COUNT_LOGINS] +1));
      $PROGRAM->meldung("danke", "LOGIN_OKAY", $HTTP_SESSION_VARS[requested_event]);
    } else {
      $PROGRAM->meldung("fehler", "LOGIN_UNGUELTIG", "");
    }
    return false;
  }

  /* public boolean */ function set_pluginlist(/* Hashtable */ $ARGS, /* String */ $event) {
    settype($ARGS, "array");
    settype($event, "string");

    global $PROGRAM,$HTTP_POST_VARS;

    if ($this->checkPermission($this->user_name,$ARGS[id],$event)) {
      # access granted

      foreach ($HTTP_POST_VARS as $a => $b) {
        settype($b, "boolean"); 
        if ($b == 1 || $b == 0) {
          $PROGRAM->plugins->setActive($a,$b);
        }
      }

      if (!$PROGRAM->plugins->write()) {
        $PROGRAM->meldung("fehler", "500", "index");
      } else {
        $PROGRAM->meldung("danke", "200", "index");
      }
    }
    return false;
  }

  /* public boolean */ function check_login(/* Hashtable */ $ARGS, /* String */ $event) {
    settype($ARGS, "array");
    settype($event, "string");

    global $PROGRAM;

    if ($this->checkPermission($this->user_name,$ARGS[id],$event)) {
      # access granted
      $PROGRAM->setRegistryKey("PERMISSION",$this->sessionManager->getUserPermission($this->user_name,$ARGS[id]));
      return true;
    } else {
      return false;
    }
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

  /* private boolean*/ function checkPermission(/* String */ $user_name,/* String */ $id, /* String */ $event) {

    settype($user_name, "string");
    settype($id, "string");
    settype($event, "string");
    global $PROGRAM;
    $user_name = strtoupper($user_name);

    $required_perm = $PROGRAM->interface->get($event, "PERMISSION");
    $user_perm     = $this->sessionManager->getUserPermission($user_name,$id);
    settype($required_perm, "integer");
    settype($user_perm, "integer");
                                 
    if ($required_perm == 0 && $user_perm > -1) { // if no permission is required, then don't care for it

      return true;

    } else {

        if (!$this->sessionManager->isLoggedIn()) {
          $meldung = "403";
          $next_action = "login";
          @session_start();
          $_SESSION["requested_event"] = $event;
        } else {
          if ($required_perm <= $user_perm) return true;
          else {
            $meldung = "UNGENUEGENDE_RECHTE";
            $next_action = "";
          }
        }
        
        $PROGRAM->setRegistryKey("TARGET", $ARGS[target]);
        $PROGRAM->meldung("hinweis", $meldung, $next_action);
        return false;
        
    }
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
