<?php

/* public */ class user_admin extends serializeableObject {

  /* private sessionManager */ var $sessionManager;
  /* private String */         var $user_name;

/*********************************************************************************************/

   /* constructor */ function user_admin(/* String */ $file) {
      session_start();
      global $PROGRAM, $HTTP_SESSION_VARS;

      if ($HTTP_SESSION_VARS[user_name]) $this->user_name = $HTTP_SESSION_VARS[user_name];
      $this->sessionManager = new sessionManager($file);
      $PROGRAM->setRegistryKey("SESSION_ID", session_id());
      $PROGRAM->setRegistryKey("SESSION_NAME", session_name());
   }

  /* public boolean */ function isEmpty() {
     return $this->sessionManager->isEmpty();
  }

  /* public boolean */ function get_user_configuration() {
    global $PROGRAM;
    $PROGRAM->setRegistryKey("BESCHREIBUNG", $PROGRAM->getRegistryKey("LANGUAGE/DESCR_USER_CONFIGURATION"));

    $USERLIST   = $this->sessionManager->getUserList();
    $USERGROUPS = $this->sessionManager->getUserGroups();
    $PROGRAM->setRegistryKey("USERLIST",$USERLIST);
    $PROGRAM->setRegistryKey("USERGROUPS",$USERGROUPS);
    return true;
  }

  /* public boolean */ function get_user_edit(/* String */ $user) {
    settype($user,"string");
    global $PROGRAM;
    $PROGRAM->setRegistryKey("BESCHREIBUNG", $PROGRAM->getRegistryKey("LANGUAGE/DESCR_USER_EDIT"));

    $USER = $this->sessionManager->getUser($user);
    
    if (!$USER[ID]) {
     $PROGRAM->meldung("fehler", "USER_UNKNOWN", "index");
     return false;
    }
    if ($USER[MAIL]) $USER[MAIL] = scanForAt($USER[MAIL]);
    $USERGROUPS = $this->sessionManager->getUserGroups();
    $PROGRAM->setRegistryKey("USER",$USER);
    $PROGRAM->setRegistryKey("USERGROUPS",$USERGROUPS);
    return true;
  }

  /* public boolean */ function set_user_edit(/* String */ $user_name, /* Hashtable */ $INPUT) {
    settype($user_name,"string");
    settype($INPUT,"array");
    global $PROGRAM;

    $INPUT = $this->makeUser($INPUT, $user_name);

    if (!$this->sessionManager->insertUser($user_name, $INPUT)) {
      $PROGRAM->meldung("fehler", "500", "index");
      return false;
    } else {
      $PROGRAM->meldung("danke", "200", "index");
      return false;
    }
  }
  
  /* public boolean */ function set_user_delete(/* String */ $user_name) {
    settype($user_name,"string");
    global $PROGRAM;

    if (strtoupper($this->user_name) == strtoupper($user_name)) {
      $PROGRAM->meldung("hinweis", "USER_DELETE_SELF", "index");
      return false;
    } else if (strtoupper($user_name) == "ADMINISTRATOR") {
      $PROGRAM->meldung("hinweis", "UNGUELTIGE_EINGABE", "index");
      return false;
    } else if (!$this->sessionManager->removeUser($user_name)) {
      $PROGRAM->meldung("fehler", "500", "index");
      return false;
    } else {
      $PROGRAM->meldung("danke", "200", "index");
      return false;
    }
  }

  /* public boolean */ function get_user_delete(/* String */ $user_name) {
    settype($user_name,"string");
    global $PROGRAM;

    if (strtoupper($this->user_name) == strtoupper($user_name)) {
      $PROGRAM->meldung("hinweis", "USER_DELETE_SELF", "index");
      return false;
    } else if (strtoupper($user_name) == "ADMINISTRATOR") {
      $PROGRAM->meldung("hinweis", "UNGUELTIGE_EINGABE", "index");
      return false;
    } else {
      return true;
    }
  }
  
  /* public boolean */ function set_user_pwd(/* String */ $user_name) {
    settype($user_name,"string");
    global $PROGRAM;
    
    $pwt = $this->sessionManager->setPwd($user_name);
    
    if (!$pwt) {
      $PROGRAM->meldung("fehler", "500", "index");
      return false;
    } else {
      $user =	$this->sessionManager->getUser($user_name);
      $user[PASSWORT] = $pwt;
      $user[NAME]     = $user[ID];
      if ($user[MAIL]) user_admin::send_mail($user[MAIL],$PROGRAM->getRegistryKey("SETTINGS/USER_PASSWORD_MAIL"),$user);
      $PROGRAM->meldung("danke", "200", "index");
      return false;
    }
  }

  /* public boolean */ function get_user_new(/* String */ $user_name) {
    settype($user_name,"string");
    $user_name = strtoupper($user_name);
    global $PROGRAM;

    if (!$user_name) {
      $PROGRAM->meldung("hinweis", "UNGUELTIGE_EINGABE", "index");
      return false;
    } else if ($this->sessionManager->userExists($user_name)) {
      $PROGRAM->meldung("hinweis", "USER_ALREADY_EXISTS", "index");
      return false;
    } else {
      $USERGROUPS = $this->sessionManager->getUserGroups();
      $PROGRAM->setRegistryKey("USERGROUPS",$USERGROUPS);
      $USER[ID]     = $user_name;
      $USER[ACTIVE] = true;
      $PROGRAM->setRegistryKey("USER",$USER);
      return true;
    }
  }

  /* public boolean */ function set_user_new(/* String */ $user_name, /* Hashtable */ $INPUT) {
    settype($user_name,"string");
    settype($INPUT,"array");

    if (!$user_name) {
      $PROGRAM->meldung("hinweis", "UNGUELTIGE_EINGABE", "index");
      return false;
    } else if ($this->sessionManager->userExists($user_name)) {
      $PROGRAM->meldung("hinweis", "USER_ALREADY_EXISTS", "index");
      return false;
    } else {
      $INPUT = $this->makeUser($INPUT, $user_name);
      $INPUT[INSERTED] = time();

      if (!$this->sessionManager->insertUser($user_name, $INPUT)) {
        $PROGRAM->meldung("fehler", "500", "index");
        return false;
      } else {
        return $this->set_user_pwd($user_name);
      }
    }
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

  /* public Hashtable */ function getUserList() {
     return $this->sessionManager->getUserList();
  }

  /* private Hashtable */ function makeUser(/* Hashtable */ $INPUT, /* String */ $user_name) {
    settype($INPUT,"array");

    $REF = array();

    foreach ($INPUT as $key=>$element) {
      settype($element, "string");
      unset($INPUT[$key]);
      $INPUT[strtoupper($key)] = strip_tags($element);
      if (preg_match("/^PERMISSION\/([\w]+)$/i",$key, $match)) {
        if ($element) {
          $REF[PERMISSION][strtoupper($match[1])] = $element;
        } # end if
      } # end if
    } # end for

    settype($INPUT[ACTIVE],"boolean");
    settype($INPUT[PHOTO_ACTIVE],"boolean");

    if (isset($INPUT[PERM_GROUP]) && $INPUT[PERM_ID]) $REF[PERMISSION][$INPUT[PERM_ID]] = $INPUT[PERM_GROUP];
    if (isset($INPUT[MAIL]))         $REF[MAIL]         = $INPUT[MAIL];
    if (isset($INPUT[PHOTO]))        $REF[PHOTO]        = $INPUT[PHOTO];
    if ($INPUT[PHOTO]) {
      if (isset($INPUT[PHOTO_ACTIVE])) $REF[PHOTO_ACTIVE] = $INPUT[PHOTO_ACTIVE];
    } else {
      $REF[PHOTO_ACTIVE] = false;
    }

    if (strtoupper($user_name) != "ADMINISTRATOR") {
      if (isset($INPUT[ACTIVE]))       $REF[ACTIVE]       = $INPUT[ACTIVE];
      if (isset($INPUT[TYPE]))         $REF[TYPE]         = $INPUT[TYPE];
    }

    return $REF;
  }

  /* private static void */ function send_mail($empfaenger,$template,$INPUT) {  
    settype($empfaenger,"string");
    settype($template,"string");
    settype($INPUT,"array");

    global $PROGRAM;                                              	
    $heute                = getdate();   
    $mail                 = new mailer($template);
    $mail->read();
    $mail->betreff        = $PROGRAM->getRegistryKey("LANGUAGE/USER/MAIL_SUBJECT")."<br>\n";
    $mail->header         = "From:".$PROGRAM->getRegistryKey("PROFILE/NOREPLY")."<br>\n";
    $mail->options       += $PROGRAM->getRegistryKey("*");
    $mail->options       += $INPUT;
    $mail->options[DATUM] = $heute[mday] . '.' . $heute[mon] . '.' . $heute[year];
    $mail->send($empfaenger);
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
